<template>
  <div class="app-container">
    <el-form v-show="showSearch" ref="queryRef" :model="queryParams" :inline="true">
      <el-form-item label="表名称" prop="tableName">
        <el-input v-model="queryParams.tableName" clearable placeholder="请输入表名称" @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="表描述" prop="tableComment">
        <el-input v-model="queryParams.tableComment" clearable placeholder="请输入表描述" @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          v-has-permi="['tool:gen:code']"
          type="primary"
          icon="Download"
          plain
          @click="handleGenTable"
        >生成</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          v-has-permi="['tool:gen:import']"
          type="info"
          icon="Upload"
          plain
          @click="openImportTable"
        >导入</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          v-has-permi="['tool:gen:edit']"
          type="success"
          icon="Edit"
          plain
          :disabled="single"
          @click="handleEditTable"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          v-has-permi="['tool:gen:remove']"
          type="danger"
          icon="Delete"
          plain
          :disabled="multiple"
          @click="handleDelete"
        >删除</el-button>
      </el-col>
      <right-toolbar v-model:show-search="showSearch" @query-table="getList" />
    </el-row>

    <el-table v-loading="loading" :data="tableList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" align="center" width="55" />
      <el-table-column label="序号" type="index" width="50" align="center">
        <template #default="scope">
          <span>{{ (queryParams.pageNumber - 1) * queryParams.pageSize + scope.$index + 1 }}</span>
        </template>
      </el-table-column>
      <el-table-column label="表名称" align="center" prop="tableName" :show-overflow-tooltip="true" />
      <el-table-column label="表描述" align="center" prop="tableComment" :show-overflow-tooltip="true" />
      <el-table-column label="实体" align="center" prop="className" :show-overflow-tooltip="true" />
      <el-table-column label="创建时间" align="center" prop="createTime" width="160" />
      <el-table-column label="更新时间" align="center" prop="updateTime" width="160" />
      <el-table-column label="操作" align="center" width="370" class-name="small-padding fixed-width">
        <template #default="scope">
          <el-button
            v-has-permi="['tool:gen:preview']"
            type="primary"
            icon="View"
            link
            @click="handlePreview(scope.row)"
          >预览</el-button>
          <el-button
            v-has-permi="['tool:gen:edit']"
            type="success"
            icon="Edit"
            link
            @click="handleEditTable(scope.row)"
          >编辑</el-button>
          <el-button
            v-has-permi="['tool:gen:remove']"
            type="danger"
            icon="Delete"
            link
            @click="handleDelete(scope.row)"
          >删除</el-button>
          <el-button
            v-has-permi="['tool:gen:edit']"
            type="primary"
            icon="Refresh"
            link
            @click="handleSynchDb(scope.row)"
          >同步</el-button>
          <el-button
            v-has-permi="['tool:gen:code']"
            type="primary"
            icon="Download"
            link
            @click="handleGenTable(scope.row)"
          >生成代码</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total > 0"
      v-model:page="queryParams.pageNumber"
      v-model:limit="queryParams.pageSize"
      :total="total"
      @pagination="getList"
    />

    <!-- 导入表弹窗 -->
    <import-table ref="importRef" @ok="handleQuery" />

    <!-- 预览界面 -->
    <el-dialog v-model="preview.open" :title="preview.title" width="80%" top="5vh" append-to-body class="scrollbar">
      <el-tabs v-model="preview.activeName">
        <el-tab-pane
          v-for="(value, key) in preview.data"
          :key="value"
          :label="key.substring(key.lastIndexOf('/')+1,key.indexOf('.vm'))"
          :name="key.substring(key.lastIndexOf('/')+1,key.indexOf('.vm'))"
        >
          <el-link v-clipboard:copy="value" v-clipboard:success="clipboardSuccess" icon="DocumentCopy" underline="never" style="float: right;">&nbsp;复制</el-link>
          <pre>
            <code class="hljs" v-html="highlightedCode(value, key)" />
          </pre>
        </el-tab-pane>
      </el-tabs>
    </el-dialog>
  </div>
</template>

<script name="Gen" setup>
import { listTable, previewTable, delTable, genCode, synchDb } from '@/api/tool/gen'
import download from '@/utils/download'
import importTable from './importTable'
import hljs from 'highlight.js/lib/core'
import 'highlight.js/styles/github-gist.css'
import java from 'highlight.js/lib/languages/java'
import xml from 'highlight.js/lib/languages/xml'
import html from 'highlight.js/lib/languages/xml'
import vue from 'highlight.js/lib/languages/xml'
import javascript from 'highlight.js/lib/languages/javascript'
import sql from 'highlight.js/lib/languages/sql'

hljs.registerLanguage('java', java)
hljs.registerLanguage('xml', xml)
hljs.registerLanguage('html', html)
hljs.registerLanguage('vue', vue)
hljs.registerLanguage('javascript', javascript)
hljs.registerLanguage('sql', sql)

const route = useRoute()
const { proxy } = getCurrentInstance()

const tableList = ref([])
const loading = ref(true)
const showSearch = ref(true)
const ids = ref([])
const single = ref(true)
const multiple = ref(true)
const total = ref(0)
const tableNames = ref([])
const uniqueId = ref('')

const data = reactive({
  queryParams: {
    pageNumber: 1,
    pageSize: 10,
    tableName: undefined,
    tableComment: undefined
  },
  preview: {
    open: false,
    title: '代码预览',
    data: {},
    activeName: 'domain.java'
  }
})

const { queryParams, preview } = toRefs(data)

onActivated(() => {
  const time = route.query.t
  if (time != null && time !== uniqueId.value) {
    uniqueId.value = time
    queryParams.value.pageNumber = Number(route.query.pageNumber)
    proxy.$resetForm('queryForm')
    getList()
  }
})

/** 查询表集合 */
function getList() {
  loading.value = true
  listTable(queryParams.value).then(res => {
    tableList.value = res.list
    total.value = Number(res.total)
    loading.value = false
  })
}
/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNumber = 1
  getList()
}
/** 重置按钮操作 */
function resetQuery() {
  proxy.$resetForm('queryRef')
  handleQuery()
}
/** 打开导入表弹窗 */
function openImportTable() {
  proxy.$refs['importRef'].show()
}
/** 预览按钮 */
function handlePreview(row) {
  previewTable(row.tableId).then(res => {
    preview.value.data = res
    preview.value.open = true
    preview.value.activeName = 'domain.java'
  })
}
/** 高亮显示 */
function highlightedCode(code, key) {
  const vmName = key.substring(key.lastIndexOf('/') + 1, key.indexOf('.vm'))
  var language = vmName.substring(vmName.indexOf('.') + 1, vmName.length)
  const result = hljs.highlight(language, code || '', true)
  return result.value || '&nbsp;'
}
/** 复制代码成功 */
function clipboardSuccess() {
  proxy.$modal.msgSuccess('复制成功')
}
// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map(item => item.tableId)
  tableNames.value = selection.map(item => item.tableName)
  single.value = selection.length !== 1
  multiple.value = !selection.length
}
/** 修改按钮操作 */
function handleEditTable(row) {
  const tableId = row.tableId || ids.value[0]
  const tableName = row.tableName || tableNames.value[0]
  const params = { pageNumber: queryParams.value.pageNumber }
  proxy.$tab.openPage('/tool/gen-edit/index/' + tableId, '修改[' + tableName + ']生成配置', params)
}
/** 删除按钮操作 */
function handleDelete(row) {
  const tableIds = row.tableId || ids.value
  proxy.$modal.confirm('是否确认删除表编号为"' + tableIds + '"的数据项？').then(function() {
    return delTable(tableIds)
  }).then(() => {
    getList()
    proxy.$modal.msgSuccess('删除成功')
  }).catch(() => {})
}
/** 同步数据库操作 */
function handleSynchDb(row) {
  const tableName = row.tableName
  proxy.$modal.confirm('确认要强制同步"' + tableName + '"表结构吗？').then(function() {
    return synchDb(tableName)
  }).then(() => {
    proxy.$modal.msgSuccess('同步成功')
  }).catch(() => {})
}
/** 生成代码操作 */
function handleGenTable(row) {
  const tbNames = row.tableName || tableNames.value
  if (tbNames == '') {
    proxy.$modal.msgError('请选择要生成的数据')
    return
  }
  if (row.genType === '1') {
    genCode(row.tableName).then(response => {
      proxy.$modal.msgSuccess('成功生成到自定义路径：' + row.genPath)
    })
  } else {
    download.zip('/tool/gen/batchGenCode?tables=' + tbNames, 'ruoyi.zip')
  }
}

getList()
</script>
